#!/bin/bash
#set -x
# hw_governor_config_9A0.
# Copyright ? Huawei Technologies Co., Ltd. 2020-2021. All rights reserved.
#set -e
WORKDIR=$(pwd)
LOGFILE=/var/log/$(basename $0).excute.log
CURRENTTIME=$(date +%Y%m%d%H%M%S)

function exec_with_log()
{
echo "begin execute $* " >> ${LOGFILE}
$* >> ${LOGFILE} 2>&1
if [[ $? == 0 ]]; then
echo "execute $* successful." >> ${LOGFILE}
else
echo "execute $* failed." >> ${LOGFILE}
fi
}

function echo_with_log()
{
echo "begin execute echo $1 > $2 " >> ${LOGFILE}
if [[ ! -f $2 ]]; then
echo "not exists $2" >> ${LOGFILE}
return 
fi
echo $1 > $2 
if [[ $? == 0 ]]; then
echo "execute $* successful." >> ${LOGFILE}
else
echo "execute $* failed." >> ${LOGFILE}
fi
}

function swap_file()
{
if [[ -d /sys/kernel/debug/swap_test ]];then
echo /data/swap_file > /sys/kernel/debug/swap_test/swapfile
fi
}

function main()
{
    [[ ! -f ${LOGFILE} ]] && ( touch ${LOGFILE} )
    echo "" > ${LOGFILE}
    echo "begin execute modify cfg, time is : ${CURRENTTIME}" >> ${LOGFILE}
    exec_with_log chmod 660 /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq
    exec_with_log chmod 660 /sys/devices/system/cpu/cpu0/cpufreq/scaling_min_freq
    exec_with_log chmod 660 /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq
    exec_with_log chmod 660 /sys/devices/system/cpu/cpu4/cpufreq/scaling_min_freq
    exec_with_log chmod 660 /sys/devices/system/cpu/cpu7/cpufreq/scaling_max_freq
    exec_with_log chmod 660 /sys/devices/system/cpu/cpu7/cpufreq/scaling_min_freq
    exec_with_log chmod 660 /sys/devices/virtual/thermal/thermal_zone0/boost
    exec_with_log chmod 660 /sys/devices/virtual/thermal/thermal_zone0/boost_timeout
    exec_with_log chmod 660 /sys/class/devfreq/gpufreq/max_freq
    exec_with_log chmod 660 /sys/class/devfreq/gpufreq/min_freq
    exec_with_log chmod 660 /sys/class/devfreq/gpufreq/cur_freq
    exec_with_log chmod 660 /sys/class/devfreq/gpufreq/available_frequencies
    exec_with_log chmod 660 /sys/class/devfreq/gpufreq/mali_ondemand/animation_boost
    exec_with_log chmod 660 /sys/class/devfreq/gpufreq/mali_ondemand/animation_boost_freq
    exec_with_log chmod 660 /sys/class/devfreq/gpufreq/mali_ondemand/cl_boost
    exec_with_log chmod 660 /sys/class/devfreq/gpufreq/mali_ondemand/cl_boost_freq
    exec_with_log chmod 644 /sys/class/devfreq/ddrfreq/max_freq
    exec_with_log chmod 644 /sys/class/devfreq/ddrfreq/min_freq
    exec_with_log chmod 644 /sys/class/devfreq/ddrfreq/ddr_bandwidth
    exec_with_log chmod 644 /sys/class/devfreq/ddrfreq/cur_freq
    exec_with_log chmod 644 /sys/class/devfreq/ddrfreq/available_frequencies
    exec_with_log chmod 660 /dev/acpuddr_link_governor_level
    exec_with_log chmod 0660 /sys/kernel/eas/boost
    exec_with_log chmod 0660 /sys/kernel/eas/capacity_margin
    exec_with_log chmod 660 /sys/class/devfreq/l3c_devfreq/max_freq
    exec_with_log chmod 660 /sys/class/devfreq/l3c_devfreq/min_freq
    exec_with_log chmod 0660 /sys/class/thermal/thermal_zone0/mode
    exec_with_log chmod 0660 /sys/class/thermal/thermal_zone0/trip_point_0_temp
    exec_with_log chmod 0660 /sys/class/thermal/thermal_zone0/trip_point_1_temp
    exec_with_log chmod 0660 /sys/class/thermal/thermal_zone0/sustainable_power
    exec_with_log chmod 0660 /sys/class/thermal/thermal_zone1/mode
    exec_with_log chmod 0440 /sys/class/thermal/thermal_zone1/type
    exec_with_log chmod 0660 /sys/class/thermal/thermal_zone1/trip_point_0_temp
    exec_with_log chmod 0660 /sys/class/thermal/thermal_zone1/sustainable_power
    exec_with_log chmod 0660 /sys/kernel/perfhub/cpuaffinity
    exec_with_log chmod 0660 /dev/cpu_dma_latency
    exec_with_log chmod 0660 /sys/devices/platform/fed40000.mali/power_policy
    exec_with_log chmod 0660 /sys/class/devfreq/gpufreq/gpu_scene_aware/scene
    exec_with_log chmod 0660 /sys/class/devfreq/gpufreq/gpu_scene_aware/user_set_freq
    exec_with_log mkdir -p /dev/cpuctl
    exec_with_log mount -t cgroup -o cpu cpu /dev/cpuctl
    exec_with_log chmod 0666 /dev/cpuctl/tasks
    exec_with_log mkdir -p /dev/cpuctl/limit
    exec_with_log chmod 0644 /dev/cpuctl/limit/tasks
    exec_with_log mkdir -p /dev/cpuset
    exec_with_log mkdir -p /dev/blkio
    exec_with_log mount -t cgroup -o cpuset cpuset /dev/cpuset
    exec_with_log mount -t cgroup -o blkio blkio /dev/blkio
    exec_with_log mount cgroup none /dev/cpuset remount blkio,cpuset,qemu
    exec_with_log mkdir -p /dev/cpuset/foreground
    exec_with_log mkdir -p /dev/cpuset/foreground/boost
    exec_with_log mkdir -p /dev/cpuset/background
    exec_with_log mkdir -p /dev/cpuset/system-background
    exec_with_log mkdir -p /dev/cpuset/top-app
    exec_with_log chmod 0775 /dev/cpuset/system-background
    exec_with_log chmod 0664 /dev/cpuset/foreground/tasks
    exec_with_log chmod 0664 /dev/cpuset/foreground/boost/tasks
    exec_with_log chmod 0664 /dev/cpuset/background/tasks
    exec_with_log chmod 0664 /dev/cpuset/system-background/tasks
    exec_with_log chmod 0664 /dev/cpuset/top-app/tasks
    exec_with_log chmod 0664 /dev/cpuset/tasks
    exec_with_log mkdir -p /dev/cpuset/vip
    exec_with_log chmod 0664 /dev/cpuset/vip/tasks
    exec_with_log chmod 0660 /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor
    exec_with_log chmod 0660 /sys/devices/system/cpu/cpu0/cpufreq/scaling_setspeed
    exec_with_log chmod 0660 /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor
    exec_with_log chmod 0660 /sys/devices/system/cpu/cpu4/cpufreq/scaling_setspeed
    exec_with_log chmod 0660 /sys/devices/system/cpu/cpu7/cpufreq/scaling_governor
    exec_with_log chmod 0660 /sys/devices/system/cpu/cpu7/cpufreq/scaling_setspeed
    exec_with_log chmod 660 /sys/kernel/debug/freqdump/loadmonitor_enable
    exec_with_log chmod 660 /sys/kernel/debug/freqdump/loadmonitor_disable

    echo_with_log "5000000000" /sys/class/devfreq/ddrfreq/max_freq
    echo_with_log "5000000000" /sys/class/devfreq/ddrfreq/min_freq
    echo_with_log "5000000000" /sys/class/devfreq/ddrfreq_latency/max_freq
    echo_with_log "5000000000" /sys/class/devfreq/ddrfreq_latency/min_freq
    echo_with_log "5000000000" /sys/class/devfreq/ddrfreq_up_threshold/max_freq
    echo_with_log "5000000000" /sys/class/devfreq/ddrfreq_up_threshold/min_freq
    echo_with_log "1024" /dev/cpuctl/cpu.shares
    echo_with_log "800000" /dev/cpuctl/cpu.rt_runtime_us
    echo_with_log "1000000" /dev/cpuctl/cpu.rt_period_us
    echo_with_log "1024" /dev/cpuctl/limit/cpu.shares
    echo_with_log "800000" /dev/cpuctl/limit/cpu.rt_runtime_us
    echo_with_log "1000000" /dev/cpuctl/limit/cpu.rt_period_us
    echo_with_log "0-7" /dev/cpuset/foreground/cpus
    echo_with_log "0" /dev/cpuset/foreground/mems
    echo_with_log "0-7" /dev/cpuset/foreground/boost/cpus
    echo_with_log "0" /dev/cpuset/foreground/boost/mems
    echo_with_log "0-3" /dev/cpuset/background/cpus
    echo_with_log "0" /dev/cpuset/background/mems
    echo_with_log "0-3" /dev/cpuset/system-background/cpus
    echo_with_log "0" /dev/cpuset/system-background/mems
    echo_with_log "0-7" /dev/cpuset/top-app/cpus
    echo_with_log "0" /dev/cpuset/top-app/mems
    echo_with_log "0-7" /dev/cpuset/vip/cpus
    echo_with_log "0" /dev/cpuset/vip/mems
    echo_with_log "mem_latency" /sys/class/devfreq/memlat_c0/governor
    echo_with_log "20" /sys/class/devfreq/memlat_c0/polling_interval
    echo_with_log "417000000" /sys/class/devfreq/memlat_c0/min_freq
    echo_with_log "2745000000" /sys/class/devfreq/memlat_c0/max_freq
    echo_with_log "400" /sys/class/devfreq/memlat_c0/mem_latency/target_ratio
    exec_with_log chmod 0660 /sys/class/devfreq/memlat_c0/polling_interval
    exec_with_log chmod 0660 /sys/class/devfreq/memlat_c0/mem_latency/target_ratio
    exec_with_log chmod 0660 /sys/class/devfreq/memlat_c0/mem_latency/monitor_enable
    echo_with_log "mem_latency" /sys/class/devfreq/memlat_c1/governor
    echo_with_log "20" /sys/class/devfreq/memlat_c1/polling_interval
    echo_with_log "417000000" /sys/class/devfreq/memlat_c1/min_freq
    echo_with_log "2745000000" /sys/class/devfreq/memlat_c1/max_freq
    echo_with_log "400" /sys/class/devfreq/memlat_c1/mem_latency/target_ratio
    exec_with_log chmod 0660 /sys/class/devfreq/memlat_c1/polling_interval
    exec_with_log chmod 0660 /sys/class/devfreq/memlat_c1/mem_latency/target_ratio
    exec_with_log chmod 0660 /sys/class/devfreq/memlat_c1/mem_latency/monitor_enable
    echo_with_log "mem_latency" /sys/class/devfreq/memlat_c2/governor
    echo_with_log "20" /sys/class/devfreq/memlat_c2/polling_interval
    echo_with_log "417000000" /sys/class/devfreq/memlat_c2/min_freq
    echo_with_log "2745000000" /sys/class/devfreq/memlat_c2/max_freq
    echo_with_log "800:1403000:500:1816000:400" /sys/class/devfreq/memlat_c2/mem_latency/target_ratio
    exec_with_log chmod 0660 /sys/class/devfreq/memlat_c2/polling_interval
    exec_with_log chmod 0660 /sys/class/devfreq/memlat_c2/mem_latency/target_ratio
    exec_with_log chmod 0660 /sys/class/devfreq/memlat_c2/mem_latency/monitor_enable
    echo_with_log "mem_latency" /sys/class/devfreq/l3_memlat_c0/governor
    echo_with_log "20" /sys/class/devfreq/l3_memlat_c0/polling_interval
    echo_with_log "413000000" /sys/class/devfreq/l3_memlat_c0/min_freq
    echo_with_log "1700000000" /sys/class/devfreq/l3_memlat_c0/max_freq
    echo_with_log "400" /sys/class/devfreq/l3_memlat_c0/mem_latency/target_ratio
    exec_with_log chmod 0660 /sys/class/devfreq/l3_memlat_c0/polling_interval
    exec_with_log chmod 0660 /sys/class/devfreq/l3_memlat_c0/mem_latency/target_ratio
    exec_with_log chmod 0660 /sys/class/devfreq/l3_memlat_c0/mem_latency/monitor_enable
    echo_with_log "mem_latency" /sys/class/devfreq/l3_memlat_c1/governor
    echo_with_log "20" /sys/class/devfreq/l3_memlat_c1/polling_interval
    echo_with_log "413000000" /sys/class/devfreq/l3_memlat_c1/min_freq
    echo_with_log "1700000000" /sys/class/devfreq/l3_memlat_c1/max_freq
    echo_with_log "400" /sys/class/devfreq/l3_memlat_c1/mem_latency/target_ratio
    exec_with_log chmod 0660 /sys/class/devfreq/l3_memlat_c1/polling_interval
    exec_with_log chmod 0660 /sys/class/devfreq/l3_memlat_c1/mem_latency/target_ratio
    exec_with_log chmod 0660 /sys/class/devfreq/l3_memlat_c1/mem_latency/monitor_enable
    echo_with_log "mem_latency" /sys/class/devfreq/l3_memlat_c2/governor
    echo_with_log "20" /sys/class/devfreq/l3_memlat_c2/polling_interval
    echo_with_log "413000000" /sys/class/devfreq/l3_memlat_c2/min_freq
    echo_with_log "1700000000" /sys/class/devfreq/l3_memlat_c2/max_freq
    echo_with_log "800:1403000:600:1691000:400" /sys/class/devfreq/l3_memlat_c2/mem_latency/target_ratio
    exec_with_log chmod 0660 /sys/class/devfreq/l3_memlat_c2/polling_interval
    exec_with_log chmod 0660 /sys/class/devfreq/l3_memlat_c2/mem_latency/target_ratio
    exec_with_log chmod 0660 /sys/class/devfreq/l3_memlat_c2/mem_latency/monitor_enable
    echo_with_log "schedutil" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor
    echo_with_log "50" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/go_hispeed_load
    echo_with_log "1700000" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/hispeed_freq
    echo_with_log "70" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/target_loads
    echo_with_log "schedutil" /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor
    echo_with_log "70" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/go_hispeed_load
    echo_with_log "1767000" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/hispeed_freq
    echo_with_log "80" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/target_loads
    echo_with_log "schedutil" /sys/devices/system/cpu/cpu7/cpufreq/scaling_governor
    echo_with_log "90" /sys/devices/system/cpu/cpu7/cpufreq/schedutil/go_hispeed_load
    echo_with_log "2170000" /sys/devices/system/cpu/cpu7/cpufreq/schedutil/hispeed_freq
    echo_with_log "80" /sys/devices/system/cpu/cpu7/cpufreq/schedutil/target_loads

    echo_with_log "0" /sys/class/devfreq/ddrfreq/min_freq
    echo_with_log "0" /sys/class/devfreq/ddrfreq/max_freq
    echo_with_log "0" /sys/class/devfreq/ddrfreq_latency/min_freq
    echo_with_log "0" /sys/class/devfreq/ddrfreq_latency/max_freq
    echo_with_log "5000000000" /sys/class/devfreq/ddrfreq_up_threshold/max_freq
    echo_with_log "5000000000" /sys/class/devfreq/ddrfreq_up_threshold/min_freq

    echo "end execute modify cfg, time is : ${CURRENTTIME}" >> ${LOGFILE}
}

main
